﻿using System;
using Spring.Serialization;
using SpringCombos;

namespace Spring.Editing
{
    public class EditEventArgs : EventArgs
    {
#region Public Enums, Properties and Fields

        public EditType Type { get; set; }

#endregion
    }

    public class EditSuccessEventArgs : EditEventArgs
    {
#region Public Enums, Properties and Fields

        public string Text { get; set; }

        public Combos Combos { get; set; }

        public string FileName { get; set; }

#endregion

#region Constructors, Destructors and Finalizers

        public EditSuccessEventArgs(EditType type,
                                    string fileName,
                                    SerializationSuccess<Combos> serializationSuccess) : this(type,
            serializationSuccess) =>
            FileName = fileName;

        public EditSuccessEventArgs(EditType editType,
                                    SerializationSuccess<Combos> serializationSuccess)
        {
            Type = editType;
            Combos = serializationSuccess.Result;
            Text = serializationSuccess.Text;
        }

#endregion
    }

    public class EditFailureEventArgs : EditEventArgs
    {
#region Public Enums, Properties and Fields

        public Exception Exception { get; set; }

#endregion

#region Constructors, Destructors and Finalizers

        public EditFailureEventArgs(SerializationFailure serializationFailure) =>
            Exception = serializationFailure.Exception;

#endregion
    }
}
